﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Collections;
using System.Threading;
using System.IO;

namespace MPSMinCon
{
    static class Rezultati
    {
        static public int[,] rezultati;
        static public int[,] rezultatiPerfundimtar;
        static internal int[,] actThjeshtimi;
        static internal int[,] fillFundProjekteve;
        static internal int[] renditjaMM;
        static public int deltaF = int.MaxValue;     
        internal static int OpExecTime;
        internal static int modesTabuListLen;
        internal static int seqTabuListLen;
        //internal static int VarSetSize = 11;
        internal static int nrSec;
        internal static DateTime stDt;
        internal static DateTime initDt;
        internal static DateTime altDt;
        //internal static int NAct;
        //internal static int NProj;
        internal static int Starti;
        internal static bool MMLib = false;
        internal static bool Over = false;
        internal static string str1;
        internal static string str;
        internal static string path;
        static internal bool[][] precRelationsPrPre;// = new bool[noActivitiesTotal][];
        static internal int[] projFill;
        static internal int[] vDct = new int[2];
        static internal Object thisLock = new Object();
        static internal int AModLen1;
        static internal int AModLen2;
        static internal int AThjLen1; 
        static internal int AThjLen2;
        static internal int[] VT = new int[6];    
        static internal Dictionary<int, int> dcTN1 =new Dictionary<int,int>();
        static internal Dictionary<int, int> dcTN2 =new Dictionary<int,int>();
        
        static internal bool IsTD(int acTs, int dimTabu, Dictionary<int, int> dcT)
        {
            if (dcT.ContainsKey(acTs))
                return true;
            else
            {
                lock (thisLock)
                {
                    try
                    {
                        if (dcT.Count > dimTabu) dcT.Remove(dcT.Keys.First());                       
                        dcT.Add(acTs, 0);
                    }
                    catch { }
                }
            }
            return false;
        }

        static internal bool IsT(int act)//int[] vT, 
        {
            int vtabL = VT.Length;
            for (int i = vtabL - 2; i >= 0; i--)
            {
                if (act == VT[i])
                {
                    for (int j = i + 1; j < vtabL - 1; j++)
                    {
                        VT[j] = VT[j + 1];
                    }
                    return true;
                }
                else { VT[i + 1] = VT[i]; }
            }
            VT[0] = act;
            return false;
        }

        static internal int GjejStartin(Problemi problemiObj)
        {
            int min = problemiObj.projectInfoPr[0, 2];//, max = -1;
            int nrProj = problemiObj.noProjects;
            int prjStart = min;
            for (int i = 1; i < nrProj; i++)
            {
                projFill[i] = problemiObj.projectInfoPr[i, 2];
                if (prjStart > projFill[i]) prjStart = projFill[i];
            }
            return prjStart;
        }


        static public void Kopjo(int[,] v1, int[,] v2)
        {
            Buffer.BlockCopy(v1, 0, v2, 0, v1.Length * sizeof(int));          
        }

        static public void AcceptanceCriterion(int indks, Solution[] solObj, int maksi)//, ref int nrPermiresime)
        {
            Thread[] th = new Thread[4];

            solObj[indks].KtheZgjidhjeZMMtoRez();
            solObj[indks].KtheRenditjeMM();

            if (maksi < Rezultati.deltaF)
            {
                Rezultati.Kopjo(Rezultati.rezultati, Rezultati.rezultatiPerfundimtar);
                Rezultati.deltaF = maksi;// deltaF0;//sYllprim;
                //nrPermiresime = 1;
            }

            for (int i = 0; i < 4; i++)
            {
                int j = i;
                th[i] = new Thread(() => solObj[j].KtheZgjidhjeReztoRACT());//
                th[i].Start();
            }
            for (int i = 0; i < 4; i++)
            {
                th[i].Join();
            }

            for (int i = 0; i < 4; i++)
            {
                int j = i;
                th[i] = new Thread(() => solObj[j].KtheRenditjetoRACT());//
                th[i].Start();
            }
            for (int i = 0; i < 4; i++)
            {
                th[i].Join();
            }                       
        }
               

        static public bool AcceptanceCriterion(int maksi, int indks, ref bool KaPermiresime, ref int nrPermiresime, Solution[] solObj)
        {
            Thread[] th = new Thread[4];
            if (maksi < Rezultati.deltaF)
            {
                solObj[indks].KtheZgjidhjeZMMtoRez();
                solObj[indks].KtheRenditjeMM();
                //solObj0.KtheZgjidhjeZMMtoRez(); 
                KaPermiresime = true;
                Rezultati.Kopjo(Rezultati.rezultati, Rezultati.rezultatiPerfundimtar);
                Rezultati.deltaF = maksi;// 
                for (int i = 0; i < 4; i++)
                {
                    int j = i;
                    th[i] = new Thread(() => solObj[j].KtheZgjidhjeReztoRACT());//
                    th[i].Start();
                }
                for (int i = 0; i < 4; i++)
                {
                    th[i].Join();
                }

                for (int i = 0; i < 4; i++)
                {
                    int j = i;
                    th[i] = new Thread(() => solObj[j].KtheRenditjetoRACT());//
                    th[i].Start();
                }
                for (int i = 0; i < 4; i++)
                {
                    th[i].Join();
                }                               
                nrPermiresime = 1;
            }
            else
            {
                KaPermiresime = false;

                for (int i = 0; i < 4; i++)
                {
                    int j = i;
                    th[i] = new Thread(() => solObj[j].KtheZgjidhjeZMMtoRACT());//
                    th[i].Start();
                }
                for (int i = 0; i < 4; i++)
                {
                    th[i].Join();
                }

                for (int i = 0; i < 4; i++)
                {
                    int j = i;
                    th[i] = new Thread(() => solObj[j].KtheRenditjeMMtoRend());//
                    th[i].Start();
                }
                for (int i = 0; i < 4; i++)
                {
                    th[i].Join();
                }             
            }
            return KaPermiresime;
        }

        static internal void ShkruajNeFile(string emrstr)
        {
            string emri = Rezultati.str + "\\" + emrstr + "_SolutionFile.txt";
            //StringBuilder rreshti=new StringBuilder();
            string rreshti;
            if (System.IO.File.Exists(emri)) System.IO.File.Delete(emri);
            for (int i = 0; i < Rezultati.actThjeshtimi.GetLength(0); i++)
            {
                rreshti = Rezultati.actThjeshtimi[i, 0].ToString() + " " + (Rezultati.actThjeshtimi[i, 1] - 1).ToString() + " " + (Rezultati.rezultatiPerfundimtar[i, 0] - 1).ToString() + " " + Rezultati.rezultatiPerfundimtar[i, 2].ToString();
                using (System.IO.StreamWriter writer = new System.IO.StreamWriter(emri, true))
                {
                    writer.WriteLine(rreshti);
                }
            }

        }


        static internal void ShkruajNeFilePSP(string emrstr)
        {
            string emri = Rezultati.str + "\\" + emrstr + "_SolutionFile.txt";
            string rreshti;
            if (System.IO.File.Exists(emri)) System.IO.File.Delete(emri);
            for (int i = 0; i < Rezultati.actThjeshtimi.GetLength(0); i++)
            {
                rreshti = (Rezultati.actThjeshtimi[i, 1]).ToString() + " " + Rezultati.rezultatiPerfundimtar[i, 2].ToString() + " " + (Rezultati.rezultatiPerfundimtar[i, 0]).ToString();
                using (System.IO.StreamWriter writer = new System.IO.StreamWriter(emri, true))
                {
                    writer.WriteLine(rreshti);
                }
            }
        }

        static internal void ShkruajParamNeFile(int h, int i, int j, int TPDTms)
        {
            string t = "T-list length", nrIter = "no Iter", pert = "Pert size", TPDtms = "TPD_TMS";
            string path = @"C:\Users\pc-1\Desktop\TstOut.txt";
            if (!File.Exists(path))
            {
                using (StreamWriter sw = File.CreateText(path))
                {
                    sw.WriteLine("{0, -16} {1,-16} {2, -16} {3, -16}", t, nrIter, pert, TPDtms);
                }
            }
            using (StreamWriter sw = File.AppendText(path))
            {
                sw.WriteLine("{0, -16} {1,-16} {2, -16} {3, -16}", h, i, j, TPDTms);
            }
        }

        static internal void InicDimens()
        {
            AThjLen1 = actThjeshtimi.GetLength(0);
            AThjLen2 = actThjeshtimi.GetLength(1);
        }

        static internal void KtheMax(out int maksi, out int indks, Solution[] solObj)
        {
            maksi = solObj[0].deltaF; indks = 0;
            if (solObj[1].deltaF < maksi) { indks = 1; maksi = solObj[1].deltaF; }
            if (solObj[2].deltaF < maksi) { indks = 2; maksi = solObj[2].deltaF; }
            if (solObj[3].deltaF < maksi) { indks = 3; maksi = solObj[3].deltaF; }
        }

        static internal void Reseto(Solution[] solObj)
        {
            for (int i = 0; i < solObj.Length; i++)
            {
                solObj[i].deltaF = int.MaxValue;
            }
        }
    }
}

//}
